﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;
namespace FlyweightPattern
{
    class Program
    {
        static void Main(string[] args)
        {
            ClothesFactory fac = new ClothesFactory();
            fac.GetClothes("黄金圣衣").GetDefense();
            fac.GetClothes("白银圣衣").GetDefense();
            fac.GetClothes("黄金圣衣").GetDefense();
            fac.GetClothes("黄金圣衣").GetDefense();
            fac.GetClothes("青铜圣衣").GetDefense();
            fac.GetClothes("白银圣衣").GetDefense();
            Console.ReadLine();
        }
    }

    abstract class Clothes
    {
        public string Name { get; set; }
        public int Defense { get; set; }
        public abstract void GetDefense();
    }

    class LowClothes : Clothes
    {
        public LowClothes()
        {
            Name = "青铜圣衣";
            Defense = 50;
        }
        public override void GetDefense()
        {
            Console.WriteLine(Name + "的防御是" + Defense);
        }
    }

    class MiddleClothes : Clothes
    {
        public MiddleClothes()
        {
            Name = "白银圣衣";
            Defense = 80;
        }
        public override void GetDefense()
        {
            Console.WriteLine(Name + "的防御是" + Defense);
        }
    }

    class HighClothes : Clothes
    {
        public HighClothes()
        {
            Name = "黄金圣衣";
            Defense = 100;
        }
        public override void GetDefense()
        {
            Console.WriteLine(Name + "的防御是" + Defense);
        }
    }
    class ClothesFactory
    {
        private Hashtable clothesHT = new Hashtable();
        public Clothes GetClothes(string clothesName)
        {
            Clothes clothes = (Clothes)clothesHT[clothesName];
            if (clothes == null)
            {
                switch (clothesName)
                {
                    case "青铜圣衣": clothes = new LowClothes();
                        break;
                    case "白银圣衣": clothes = new MiddleClothes();
                        break;
                    case "黄金圣衣": clothes = new HighClothes();
                        break;
                }
                clothesHT.Add(clothesName, clothes);
            }
            return clothes;
        }
    }
}
